//PASSWORD
function Password(parent, open = false) {

    let password = document.createElement("input")
    password.setAttribute('type', 'password')
    password.placeholder = "Enter your password"
    parent.appendChild(password)

    let checkBox = document.createElement("input")
    checkBox.type = "checkbox"
    parent.appendChild(checkBox)

    this.setValue = value => password.value = value
    this.setOpen = open => checkBox.checked = open

    this.getValue = () => password.value
    this.getOpen = () => checkBox.checked
    this.getPassword = () => password
    this.getCheckBox = () => checkBox
    this.getCheckBoxDisplay = (value) => checkBox.style.display = value
    this.onChange = data => console.log(data)
    this.onOpenChange = open => open === true ? password.type = "text" : password.type = "password"

    password.oninput = () => this.onChange(this.getValue())
    checkBox.onchange = () => this.onOpenChange(this.getOpen())

    this.setOpen(open)
}

//let password = new Password(document.body)

// LoginForm

function Login(parent, value = "") {
    let login = document.createElement("input")
    login.setAttribute("type", "text")
    login.placeholder = "Enter your login"
    parent.appendChild(login)

    this.setValue = value => login.value = value

    this.getValue = () => login.value
    this.getLogin = () => login

    this.onChange = data => console.log(data)
    login.oninput = () => this.onChange(this.getValue())
    this.setValue(value)
}

function Button(parent) {
    let btn = document.createElement("button")
    btn.innerHTML = 'OK'
    parent.appendChild(btn)
    this.setDisabled = value => btn.disabled = value
    this.getBtn = () => btn
    this.setDisabled(true)
}

function LoginForm(parent) {
    let form = document.createElement("form")
    parent.appendChild(form)

    let login = new Login(form)
    let password = new Password(form)
    let btn = new Button(form)

    this.checkBtn = () => {
        if (login.getValue() !== "" && password.getValue() !== "") {
            btn.setDisabled(false)
        } else {
            btn.setDisabled(true)
        }
    }

    login.getLogin().addEventListener("input", this.checkBtn)
    password.getPassword().addEventListener("input", this.checkBtn)

    btn.getBtn().onclick = () => {
        let data = {
            login: login.getValue(),
            password: password.getValue()
        }
    }
}
let loginForm = new LoginForm(document.body, true)

function PasswordVerifyForm(parent) {

    let form = document.createElement("form")
    parent.appendChild(form)

    let firstPassword = new Password(form)
    let secondPassword = new Password(form)
    let btn = new Button(form)
    secondPassword.getCheckBoxDisplay('none');
    secondPassword.onOpenChange(false)

    this.verifyBtn = () => {
        if (firstPassword.getValue() === secondPassword.getValue()) {
            btn.setDisabled(false)
        } else {
            btn.setDisabled(true)
        }
    }

    this.openSecondPassword = () => {
        if (firstPassword.getOpen()) {
            secondPassword.getPassword().style.display = 'none'
        } else {
            secondPassword.getPassword().style.display = 'inline-block'
        }
    }

    firstPassword.getPassword().addEventListener("input", this.verifyBtn)
    secondPassword.getPassword().addEventListener("input", this.verifyBtn)
    firstPassword.getCheckBox().addEventListener("click", this.openSecondPassword)

    btn.getBtn().onclick = () => {
        let data = {
            password: firstPassword.getValue()
        }
    }
}

let passwordVerify = new PasswordVerifyForm(document.body)
